## veyon 4.4.1+repack1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.1.0)

PROJECT(veyon)

SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH})
IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
    SET(VEYON_DEBUG TRUE)
ELSEIF(NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE relwithdebinfo)
ENDIF()

IF(VEYON_DEBUG)
    ADD_DEFINITIONS(-DVEYON_DEBUG)
ENDIF()

set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

IF(COMMAND CMAKE_POLICY)
    CMAKE_POLICY(SET CMP0009 NEW)
	CMAKE_POLICY(SET CMP0020 NEW)
	CMAKE_POLICY(SET CMP0063 NEW)
	if(${CMAKE_VERSION} VERSION_GREATER "3.12.0")
		cmake_policy(SET CMP0075 NEW)
	endif()
	if(${CMAKE_VERSION} VERSION_GREATER "3.14.0")
		cmake_policy(SET CMP0083 NEW)
	endif()
ENDIF()

INCLUDE(AddFileDependencies)
INCLUDE(CheckCSourceCompiles)
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckTypeSize)
INCLUDE(GNUInstallDirs)
INCLUDE(CotireVeyon)
INCLUDE(ConfigureFiles)
include(SetDefaultTargetProperties)

FIND_PACKAGE(Git)

IF(GIT_FOUND)
    EXECUTE_PROCESS(COMMAND "${GIT_EXECUTABLE}" describe --tags
		            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
					OUTPUT_STRIP_TRAILING_WHITESPACE
					OUTPUT_VARIABLE VERSION_STRING)
	STRING(REGEX REPLACE "^v([0-9]+)\\..*" "\\1" VERSION_MAJOR "${VERSION_STRING}")
	STRING(REGEX REPLACE "^v[0-9]+\\.([0-9]+).*" "\\1" VERSION_MINOR "${VERSION_STRING}")
	STRING(REGEX REPLACE "^v[0-9]+\\.[0-9]+\\.([0-9]+).*" "\\1" VERSION_PATCH "${VERSION_STRING}")

	# determine build number to use in NSIS installer and resource files
	EXECUTE_PROCESS(COMMAND "${GIT_EXECUTABLE}" describe --tags
		            COMMAND cut -d "-" -f2
					WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
					OUTPUT_STRIP_TRAILING_WHITESPACE
					OUTPUT_VARIABLE VERSION_BUILD)
	IF(NOT VERSION_BUILD GREATER 0)
	    SET(VERSION_BUILD 0)
	ENDIF()

	# Get list of all committers from git history, ordered by number of commits.
	# The CONTRIBUTORS file is used by AboutDialog. This information can be provided
	# with -DCONTRIBUTORS=/path/to/CONTRIBUTORS instead. For instance, to generate
	# this file for version 3.0.2, the command is:
	#   git shortlog -sne v3.0.2 | cut -c8-
	SET(CONTRIBUTORS "${CMAKE_BINARY_DIR}/CONTRIBUTORS")
	IF(NOT EXISTS "${CONTRIBUTORS}")
		EXECUTE_PROCESS(COMMAND "${GIT_EXECUTABLE}" shortlog -s d160d147165271516589c304cb1b8f5e48f8527d..HEAD
			            COMMAND cut -c8-
						COMMAND sort -f
						OUTPUT_FILE "${CONTRIBUTORS}"
						WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
						TIMEOUT 10)
	ENDIF()

ENDIF()

# can't retrieve version information as not building from Git repository?
IF(NOT VERSION_STRING)
    SET(VERSION_MAJOR 4)
	SET(VERSION_MINOR 4)
	SET(VERSION_PATCH 1)
	SET(VERSION_BUILD 0)
	SET(VERSION_STRING "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
ELSE()
    # remove leading character from tag name
	STRING(REPLACE "v" "" VERSION_STRING "${VERSION_STRING}")
ENDIF()

# set up compiler version variable
STRING(REGEX REPLACE "\\.[0-9]$" "" COMPILER_VERSION_MAJOR_MINOR ${CMAKE_CXX_COMPILER_VERSION})


# set up basic platform variables
IF(WIN32)
    SET(VEYON_BUILD_WIN32 1)
ENDIF()
IF(APPLE)
	SET(VEYON_BUILD_APPLE 1)
ENDIF()
IF(UNIX AND NOT ANDROID)
	SET(VEYON_BUILD_LINUX 1)
ENDIF()
IF(ANDROID)
	SET(VEYON_BUILD_ANDROID 1)
ENDIF()

IF(WIN64)
    SET(VEYON_BUILD_WIN64 TRUE)
ENDIF(WIN64)

# set up library and plugin path variables
IF(VEYON_BUILD_ANDROID)
	SET(CMAKE_INSTALL_PREFIX "/")
	SET(VEYON_LIB_DIR "libs/${ANDROID_ABI}")
	SET(VEYON_INSTALL_PLUGIN_DIR "${VEYON_LIB_DIR}/veyon")
	SET(VEYON_INSTALL_DATA_DIR "${CMAKE_INSTALL_DATADIR}/veyon")
	SET(VEYON_PLUGIN_DIR "")
	SET(VEYON_TRANSLATIONS_DIR "/translations")
ELSE()
	IF(CMAKE_INSTALL_LIBDIR)
		SET(VEYON_LIB_DIR "${CMAKE_INSTALL_LIBDIR}/veyon" CACHE INTERNAL "Veyon library directory")
	ELSE()
		SET(VEYON_LIB_DIR lib/veyon CACHE INTERNAL "Veyon library directory")
	ENDIF()

	SET(VEYON_INSTALL_PLUGIN_DIR "${VEYON_LIB_DIR}")
	SET(VEYON_INSTALL_DATA_DIR "${CMAKE_INSTALL_DATADIR}/veyon")

	IF(WIN32)
		SET(VEYON_PLUGIN_DIR "plugins")
		SET(VEYON_TRANSLATIONS_DIR "translations")
	ELSE()
		SET(VEYON_PLUGIN_DIR "../${VEYON_LIB_DIR}")
		SET(VEYON_TRANSLATIONS_DIR "../share/veyon/translations")
	ENDIF()
ENDIF()


SET(VEYON_CORE_INCLUDE_DIR core/include)

# find required Qt5 modules
FIND_PACKAGE(Qt5Core REQUIRED)
FIND_PACKAGE(Qt5Concurrent REQUIRED)
FIND_PACKAGE(Qt5Gui REQUIRED)
FIND_PACKAGE(Qt5Widgets REQUIRED)
FIND_PACKAGE(Qt5Network REQUIRED)
FIND_PACKAGE(Qt5LinguistTools REQUIRED)
IF(VEYON_DEBUG)
FIND_PACKAGE(Qt5Test REQUIRED)
SET(VEYON_DEBUG_LIBRARIES Qt5::Test)
ENDIF()

# find required libraries
find_package(QCA REQUIRED)
find_package(OpenSSL REQUIRED)

# find Linux-specific packages
IF(VEYON_BUILD_LINUX)
	INCLUDE(XdgInstall)
ENDIF()

find_package(LibVNCClient 0.9.13)

if(LibVNCClient_FOUND)
	include(CheckCSourceCompiles)
	set(CMAKE_REQUIRED_LIBRARIES LibVNC::LibVNCClient)
	check_c_source_compiles("
#include <rfb/rfbclient.h>

int main()
{
	rfbClient* client = rfbGetClient( 8, 3, 4 );
	client->connectTimeout = 1;
	client->readTimeout = 1;
	return 0;
}
"
	LIBVNCCLIENT_SUPPORTS_TIMEOUTS)
	if(NOT LIBVNCCLIENT_SUPPORTS_TIMEOUTS)
		message(FATAL_ERROR "Outdated development version of LibVNCClient found")
	endif()
	unset(CMAKE_REQUIRED_LIBRARIES)
else()
	message(WARNING "Performing internal build of LibVNCClient which requires additional development packages")
	find_package(ZLIB REQUIRED)
	find_package(PNG REQUIRED)
	find_package(JPEG REQUIRED)
	find_package(LZO REQUIRED)
	set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
	find_package(Threads REQUIRED)
endif()

IF(SANITIZE)
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread -fsanitize=undefined")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=thread -fsanitize=undefined")
ENDIF()

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fno-exceptions -std=c++11 -fstack-protector-strong ${CXXFLAGS}")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -fstack-protector-strong ${CFLAGS}")

IF(CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0)
MESSAGE(WARNING "Not using -fvisibility=hidden as it is broken with GCC < 6.0")
ELSE()
SET(CMAKE_C_VISIBILITY_PRESET hidden)
SET(CMAKE_CXX_VISIBILITY_PRESET hidden)
SET(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
IF(LTO)
SET(LTO_FLAGS "-flto=4")
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${LTO_FLAGS}")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${LTO_FLAGS}")
SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${LTO_FLAGS}")
SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${LTO_FLAGS}")
SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${LTO_FLAGS}")
ENDIF()
ENDIF()

add_definitions(-DQT_DEPRECATED_WARNINGS -DQT_DISABLE_DEPRECATED_BEFORE=0x050e00 -D_FORTIFY_SOURCE=2 -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII -DQT_NO_CAST_FROM_BYTEARRAY -DQT_NO_KEYWORDS)

FILE(GLOB_RECURSE IN_FILES RELATIVE ${CMAKE_SOURCE_DIR} "*config.h.in" "*.rc.in" "*.desktop.in" "*.policy.in" "*.service.in" "*.manifest.in" "*.nsi.in")
CONFIGURE_FILES(${IN_FILES})

SET(CMAKE_AUTOMOC TRUE)
SET(CMAKE_AUTOUIC TRUE)
SET(CMAKE_AUTORCC TRUE)

SET(3rdparty_DIR ${CMAKE_SOURCE_DIR}/3rdparty)
SET(ultravnc_DIR ${3rdparty_DIR}/ultravnc)
SET(libvncserver_DIR ${3rdparty_DIR}/libvncserver)
SET(x11vnc_DIR ${3rdparty_DIR}/x11vnc)
SET(libfakekey_DIR ${3rdparty_DIR}/libfakekey)

SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${VEYON_LIB_DIR}")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# make sub-directories
ADD_SUBDIRECTORY(core)
ADD_SUBDIRECTORY(server)
ADD_SUBDIRECTORY(service)
ADD_SUBDIRECTORY(master)
ADD_SUBDIRECTORY(configurator)
ADD_SUBDIRECTORY(cli)
ADD_SUBDIRECTORY(worker)
ADD_SUBDIRECTORY(plugins)
ADD_SUBDIRECTORY(translations)

#
# add Windows installer related targets
#
if(WIN32)
	include(WindowsInstaller)
endif()

#
# package generation
#
INCLUDE(cmake/CPackDefinitions.cmake)



#
# display configuration information
#

MESSAGE("\n"
"Veyon build summary\n"
"--------------------\n"
"* Version                     : ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_BUILD} (${VERSION_STRING})\n"
"* Install prefix              : ${CMAKE_INSTALL_PREFIX}\n"
"* Library directory           : ${CMAKE_INSTALL_PREFIX}/${VEYON_LIB_DIR}\n"
"* Plugin directory            : ${CMAKE_INSTALL_PREFIX}/${VEYON_INSTALL_PLUGIN_DIR}\n"
"* Build type                  : ${CMAKE_BUILD_TYPE}\n"
"* Build platform              : ${CMAKE_SYSTEM_PROCESSOR}\n"
"* Compile flags               : ${CMAKE_C_FLAGS} (CXX: ${CMAKE_CXX_FLAGS})\n"
)

IF(VEYON_BUILD_ANDROID)
	INCLUDE(AndroidDeployQt)
	SET(CMAKE_ANDROID_DIR "${CMAKE_SOURCE_DIR}/android")
	SET(_CMAKE_ANDROID_DIR "${CMAKE_ANDROID_DIR}")
	SET(ANDROID_INSTALL_DIR "${CMAKE_BINARY_DIR}/install")
	SET(ANDROID_EXTRA_PLUGINS ${ANDROID_INSTALL_DIR}/${VEYON_LIB_DIR}/veyon/ ${QT_DIR}/lib/qca-qt5/crypto)
	FILE(GLOB ANDROID_EXTRA_LIBS ${ANDROID_INSTALL_DIR}/${VEYON_LIB_DIR}/*.so)
	LIST(APPEND ANDROID_EXTRA_LIBS "${ANDROID_SYSROOT_GENERIC}/libc++_shared.so")
	LIST(APPEND ANDROID_EXTRA_LIBS "${QT_DIR}/lib/libldap.so"
									"${QT_DIR}/lib/liblber.so"
									"${QT_DIR}/lib/libsasl2.so")
	androiddeployqt("veyon-master" "${ANDROID_ADDITIONAL_FIND_ROOT_PATH};${CMAKE_BINARY_DIR}/core")
	SET_TARGET_PROPERTIES(create-apk-veyon-master PROPERTIES ANDROID_APK_DIR "${CMAKE_ANDROID_DIR}")

	add_custom_target(prepare-apk
		COMMAND rm -rf ${ANDROID_INSTALL_DIR}
		COMMAND cd ${CMAKE_BINARY_DIR}/core && make DESTDIR=${ANDROID_INSTALL_DIR} install
		COMMAND cd ${CMAKE_BINARY_DIR}/plugins && make DESTDIR=${ANDROID_INSTALL_DIR} install
	)

	add_dependencies(create-apk-veyon-master prepare-apk)
ENDIF()

=== core/CMakeLists.txt ===
FILE(GLOB veyoncore_INCLUDES
						${CMAKE_CURRENT_SOURCE_DIR}/include/*.h
						${CMAKE_CURRENT_SOURCE_DIR}/include/Configuration/*.h
)
FILE(GLOB veyoncore_SOURCES
						${CMAKE_CURRENT_SOURCE_DIR}/src/*.c
						${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp
						${CMAKE_CURRENT_SOURCE_DIR}/src/*.ui
						${CMAKE_CURRENT_SOURCE_DIR}/src/Configuration/*.cpp
)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/builddata.qrc.in ${CMAKE_CURRENT_BINARY_DIR}/builddata.qrc)
SET(core_RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/resources/core.qrc ${CMAKE_CURRENT_BINARY_DIR}/builddata.qrc)

if(NOT LibVNCClient_FOUND)
	set(libvncclient_SOURCES
		${libvncserver_DIR}/libvncclient/cursor.c
		${libvncserver_DIR}/libvncclient/listen.c
		${libvncserver_DIR}/libvncclient/rfbproto.c
		${libvncserver_DIR}/libvncclient/sockets.c
		${libvncserver_DIR}/libvncclient/tls_openssl.c
		${libvncserver_DIR}/libvncclient/vncviewer.c
		${libvncserver_DIR}/common/crypto_openssl.c
		${libvncserver_DIR}/common/turbojpeg.c)

	set_source_files_properties(${libvncclient_SOURCES} PROPERTIES COMPILE_FLAGS "-Wno-unused-function -Wno-unused-variable -fvisibility=default")
endif()

ADD_DEFINITIONS(-DBUILD_VEYON_CORE_LIBRARY)

ADD_LIBRARY(veyon-core SHARED ${veyoncore_SOURCES} ${veyoncore_INCLUDES} ${core_RESOURCES} ${libvncclient_SOURCES})

# find Qt's translation directory
if(NOT VEYON_BUILD_WIN32)
	include(FindQtTranslations)
	find_qt_translations()
	target_compile_definitions(veyon-core PRIVATE QT_TRANSLATIONS_DIR="${QT_TRANSLATIONS_DIR}")
endif()

set_default_target_properties(veyon-core)
target_compile_options(veyon-core PRIVATE -Wno-parentheses)

target_include_directories(veyon-core PUBLIC
	${CMAKE_CURRENT_BINARY_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}/include
	${CMAKE_CURRENT_BINARY_DIR}/include
	${QCA_INCLUDE_DIR}
)

TARGET_LINK_LIBRARIES(veyon-core
	Qt5::Concurrent
	Qt5::Gui
	Qt5::Network
	Qt5::Widgets
	OpenSSL::SSL
	${VEYON_DEBUG_LIBRARIES}
	${QCA_LIBRARY}
	)

if(LibVNCClient_FOUND)
	target_link_libraries(veyon-core LibVNC::LibVNCClient)
else()
	target_include_directories(veyon-core PRIVATE
		${ZLIB_INCLUDE_DIR}
		${JPEG_INCLUDE_DIR}
		${LZO_INCLUDE_DIR}
	)
	target_include_directories(veyon-core PUBLIC
		${libvncserver_DIR}/common/
		${libvncserver_DIR}
	)
	target_link_libraries(veyon-core
		Threads::Threads
		PNG::PNG
		${ZLIB_LIBRARIES}
		${JPEG_LIBRARIES}
		${LZO_LIBRARIES}
	)
endif()

IF(VEYON_BUILD_WIN32)
	# add Windows Socket library required by libvncclient
	TARGET_LINK_LIBRARIES(veyon-core -lws2_32)
	SET_TARGET_PROPERTIES(veyon-core PROPERTIES PREFIX "")
	INSTALL(TARGETS veyon-core RUNTIME DESTINATION ${VEYON_LIB_DIR})
ELSE()
	INSTALL(TARGETS veyon-core LIBRARY DESTINATION ${VEYON_LIB_DIR})
ENDIF(VEYON_BUILD_WIN32)

COTIRE_VEYON(veyon-core)

=== master/CMakeLists.txt ===
INCLUDE(BuildVeyonApplication)
INCLUDE(WindowsBuildHelpers)

SET(kitemmodels_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/kitemmodels/src/core)
SET(kitemmodels_SOURCES
	${kitemmodels_SOURCE_DIR}/kextracolumnsproxymodel.cpp
	${kitemmodels_SOURCE_DIR}/krecursivefilterproxymodel.cpp
	${kitemmodels_SOURCE_DIR}/kextracolumnsproxymodel.h
	${kitemmodels_SOURCE_DIR}/krecursivefilterproxymodel.h
)

FILE(GLOB master_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.h)
FILE(GLOB master_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp ${CMAKE_CURRENT_SOURCE_DIR}/src/*.ui)

SET(master_RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/resources/master.qrc)
IF(VEYON_DEBUG)
SET(master_RESOURCES ${master_RESOURCES} ${CMAKE_CURRENT_SOURCE_DIR}/resources/examples.qrc)
ENDIF()

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/src ${kitemmodels_SOURCE_DIR})
build_veyon_application(veyon-master ${master_SOURCES} ${master_INCLUDES} ${master_RESOURCES} ${kitemmodels_SOURCES})
TARGET_LINK_LIBRARIES(veyon-master veyon-core)

ADD_WINDOWS_RESOURCE(veyon-master)
MAKE_GRAPHICAL_APP(veyon-master)

IF(VEYON_BUILD_LINUX)
	XDG_INSTALL(${CMAKE_CURRENT_BINARY_DIR}/data/veyon-master.desktop ${CMAKE_CURRENT_SOURCE_DIR}/data/veyon-master.xpm ${CMAKE_CURRENT_SOURCE_DIR}/data/veyon-master.png ${CMAKE_CURRENT_SOURCE_DIR}/data/veyon-master.svg)
ENDIF()

remove_definitions(-DQT_NO_KEYWORDS)
set_source_files_properties(${master_SOURCES} PROPERTIES COMPILE_DEFINITIONS QT_NO_KEYWORDS)

# enable again once kitemmodels compile with QT_NO_KEYWORDS and the remove_definitions/set_source_files_properties above can be removed
# cotire_veyon(veyon-master)

=== translations/CMakeLists.txt ===
include(CreateTranslations)
include(FindQtTranslations)

file(GLOB veyon_translations ${CMAKE_CURRENT_SOURCE_DIR}/*.ts)
set(ts_targets "")
set(qm_targets "")
file(GLOB_RECURSE veyon_sources ${CMAKE_SOURCE_DIR}/*.cpp ${CMAKE_SOURCE_DIR}/*.h ${CMAKE_SOURCE_DIR}/*.ui ${CMAKE_SOURCE_DIR}/*.qml)
string(REGEX REPLACE "${CMAKE_SOURCE_DIR}/3rdparty[^;]+;?" "" veyon_sources "${veyon_sources}")
string(REGEX REPLACE "${CMAKE_SOURCE_DIR}/plugins/addons[^;]+;?" "" veyon_sources "${veyon_sources}")

create_translations(veyon "${veyon_translations}" "${veyon_sources}")
find_qt_translations()

=== worker/CMakeLists.txt ===
INCLUDE(BuildVeyonApplication)
INCLUDE(WindowsBuildHelpers)

FILE(GLOB worker_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.h)
FILE(GLOB worker_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/src)
build_veyon_application(veyon-worker ${worker_SOURCES} ${worker_INCLUDES})
TARGET_LINK_LIBRARIES(veyon-worker veyon-core Qt5::Network)

ADD_WINDOWS_RESOURCE(veyon-worker)
MAKE_GRAPHICAL_APP(veyon-worker)

COTIRE_VEYON(veyon-worker)

=== 3rdparty/kldap/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
set(PIM_VERSION "5.14.40")

project(KLdap VERSION ${PIM_VERSION})

# ECM setup
set(KF5_MIN_VERSION "5.69.0")

find_package(ECM ${KF5_MIN_VERSION} CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${KLdap_SOURCE_DIR}/cmake ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)

include(GenerateExportHeader)
include(ECMGenerateHeaders)
include(ECMGeneratePriFile)

include(ECMSetupVersion)
include(FeatureSummary)
include(ECMQtDeclareLoggingCategory)


set(KLDAP_LIB_VERSION ${PIM_VERSION})

find_package(KF5KIO ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5I18n ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5DocTools ${KF5_MIN_VERSION} CONFIG REQUIRED)


ecm_setup_version(PROJECT VARIABLE_PREFIX KLDAP
                        VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kldap_version.h"
                        PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF5LdapConfigVersion.cmake"
                        SOVERSION 5
)

########### Find packages ###########
find_package(KF5WidgetsAddons ${KF5_MIN_VERSION} CONFIG REQUIRED)

add_definitions(-DQT_NO_FOREACH)
add_definitions(-DQT_NO_KEYWORDS)
if (EXISTS "${CMAKE_SOURCE_DIR}/.git")
   add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050e00)
   add_definitions(-DKF_DISABLE_DEPRECATED_BEFORE_AND_AT=0x054500)
endif()

find_package(Ldap)
set_package_properties(Ldap PROPERTIES
  TYPE RECOMMENDED
  PURPOSE "Needed to provide LDAP functionality in KDE"
)

find_package(Sasl2)
set_package_properties(Sasl2 PROPERTIES TYPE REQUIRED)

if (Ldap_FOUND)
   set(LDAP_FOUND 1)
endif()

add_definitions(-DTRANSLATION_DOMAIN=\"libkldap5\")


########### CMake Config Files ###########
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KF5Ldap")

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/KF5LdapConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/KF5LdapConfig.cmake"
  INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
)

install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/KF5LdapConfig.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/KF5LdapConfigVersion.cmake"
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  COMPONENT Devel
)

install(EXPORT KF5LdapTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" FILE KF5LdapTargets.cmake NAMESPACE KF5::)

install(FILES
   ${CMAKE_CURRENT_BINARY_DIR}/kldap_version.h
   DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF5}
   COMPONENT Devel
)

########### Targets ###########
add_subdirectory(src)
add_subdirectory(kioslave)
if(BUILD_TESTING)
    add_subdirectory(autotests)
endif()

ecm_qt_install_logging_categories(
        EXPORT KLDAP
        FILE kldap.categories
        DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
        )

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== plugins/filetransfer/CMakeLists.txt ===
INCLUDE(BuildVeyonPlugin)

build_veyon_plugin(filetransfer
	FileTransferPlugin.cpp
	FileTransferPlugin.h
	FileTransferController.cpp
	FileTransferController.h
	FileTransferListModel.cpp
	FileTransferListModel.h
	FileTransferDialog.cpp
	FileTransferDialog.h
	FileTransferDialog.ui
	FileTransferUserConfiguration.h
	FileReadThread.cpp
	FileReadThread.h
	filetransfer.qrc
)

=== plugins/ldap/common/CMakeLists.txt ===
SET(ldap_common_SOURCES
	LdapBrowseDialog.cpp
	LdapBrowseDialog.ui
	LdapBrowseDialog.h
	LdapBrowseModel.cpp
	LdapBrowseModel.h
	LdapClient.cpp
	LdapClient.h
	LdapConfiguration.cpp
	LdapConfiguration.h
	LdapConfigurationPage.h
	LdapConfigurationPage.cpp
	LdapConfigurationPage.ui
	LdapDirectory.cpp
	LdapDirectory.h
	LdapNetworkObjectDirectory.cpp
	LdapNetworkObjectDirectory.h
	ldap.qrc
	)

ADD_LIBRARY(ldap-common SHARED ${ldap_common_SOURCES})
TARGET_INCLUDE_DIRECTORIES(ldap-common PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
TARGET_INCLUDE_DIRECTORIES(ldap-common PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
TARGET_LINK_LIBRARIES(ldap-common kldap-light veyon-core)
set_default_target_properties(ldap-common)
SET_TARGET_PROPERTIES(ldap-common PROPERTIES LINK_FLAGS "-Wl,-no-undefined")
INSTALL(TARGETS ldap-common DESTINATION ${VEYON_LIB_DIR})
COTIRE_VEYON(ldap-common)

=== plugins/ldap/kldap/CMakeLists.txt ===
INCLUDE(BuildVeyonPlugin)

# libraries and functions for LDAP support
FIND_PACKAGE(Ldap REQUIRED)
FIND_PACKAGE(Sasl2 REQUIRED)

SET(CMAKE_REQUIRED_INCLUDES lber.h ldap.h)
SET(CMAKE_REQUIRED_LIBRARIES ${Ldap_LIBRARIES} ${Sasl2_LIBRARIES} ${OPENSSL_LIBRARIES})
CHECK_FUNCTION_EXISTS(ldap_start_tls_s HAVE_LDAP_START_TLS_S)
CHECK_FUNCTION_EXISTS(ldap_initialize HAVE_LDAP_INITIALIZE)
CHECK_FUNCTION_EXISTS(ber_memfree HAVE_BER_MEMFREE)
CHECK_FUNCTION_EXISTS(ldap_unbind_ext HAVE_LDAP_UNBIND_EXT)
CHECK_FUNCTION_EXISTS(ldap_extended_operation HAVE_LDAP_EXTENDED_OPERATION)
CHECK_FUNCTION_EXISTS(ldap_extended_operation_s HAVE_LDAP_EXTENDED_OPERATION_S)
CHECK_SYMBOL_EXISTS(ldap_extended_operation ldap.h HAVE_LDAP_EXTENDED_OPERATION_PROTOTYPE)
CHECK_SYMBOL_EXISTS(ldap_extended_operation_s ldap.h HAVE_LDAP_EXTENDED_OPERATION_S_PROTOTYPE)
CHECK_INCLUDE_FILES(ldap.h HAVE_LDAP_H)
SET(LDAP_FOUND TRUE)

SET(kldap_SOURCE_DIR ${CMAKE_SOURCE_DIR}/3rdparty/kldap/src)
CONFIGURE_FILE(${kldap_SOURCE_DIR}/kldap_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/kldap_config.h)

SET(kldap_SOURCES
	${kldap_SOURCE_DIR}/ber.cpp
	${kldap_SOURCE_DIR}/ldif.cpp
	${kldap_SOURCE_DIR}/ldapurl.cpp
	${kldap_SOURCE_DIR}/ldapserver.cpp
	${kldap_SOURCE_DIR}/ldapobject.cpp
	${kldap_SOURCE_DIR}/ldapconnection.cpp
	${kldap_SOURCE_DIR}/ldapoperation.cpp
	${kldap_SOURCE_DIR}/ldapcontrol.cpp
	${kldap_SOURCE_DIR}/ldapdn.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/KLdapIntegration.cpp
)

ADD_LIBRARY(kldap-light SHARED ${kldap_SOURCES})
TARGET_LINK_LIBRARIES(kldap-light Qt5::Core ${Ldap_LIBRARIES} ${Sasl2_LIBRARIES})
TARGET_INCLUDE_DIRECTORIES(kldap-light PRIVATE ${Ldap_INCLUDE_DIRS})
TARGET_INCLUDE_DIRECTORIES(kldap-light PUBLIC ${kldap_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
SET_TARGET_PROPERTIES(kldap-light PROPERTIES LINK_FLAGS "-Wl,-no-undefined")
INSTALL(TARGETS kldap-light DESTINATION ${VEYON_LIB_DIR})
COTIRE_VEYON(kldap-light)

=== plugins/platform/linux/CMakeLists.txt ===
ADD_SUBDIRECTORY(auth-helper)

FIND_PACKAGE(X11 REQUIRED)
FIND_PACKAGE(Qt5DBus REQUIRED)
FIND_PACKAGE(PkgConfig QUIET)
pkg_check_modules(procps REQUIRED libprocps)
pkg_check_modules(fakekey libfakekey)

INCLUDE(BuildVeyonPlugin)

IF(NOT fakekey_FOUND)
SET(libfakekey_SOURCES ${libfakekey_DIR}/src/libfakekey.c)
SET_SOURCE_FILES_PROPERTIES(${libfakekey_SOURCES} PROPERTIES
	COMPILE_FLAGS "-Wno-deprecated-declarations -Wno-pointer-sign"
	COTIRE_EXCLUDED TRUE)
ENDIF()

build_veyon_plugin(linux-platform
	LinuxPlatformPlugin.cpp
	LinuxCoreFunctions.cpp
	LinuxPlatformConfigurationPage.h
	LinuxPlatformConfigurationPage.cpp
	LinuxPlatformConfigurationPage.ui
	LinuxFilesystemFunctions.cpp
	LinuxInputDeviceFunctions.cpp
	LinuxNetworkFunctions.cpp
	LinuxServiceCore.cpp
	LinuxServiceFunctions.cpp
	LinuxSessionFunctions.cpp
	LinuxUserFunctions.cpp
	LinuxPlatformPlugin.h
	LinuxPlatformConfiguration.h
	LinuxCoreFunctions.h
	LinuxDesktopIntegration.h
	LinuxFilesystemFunctions.h
	LinuxInputDeviceFunctions.h
	LinuxKeyboardInput.h
	LinuxKeyboardInput.cpp
	LinuxKeyboardShortcutTrapper.h
	LinuxNetworkFunctions.h
	LinuxServiceCore.h
	LinuxServiceFunctions.h
	LinuxSessionFunctions.h
	LinuxUserFunctions.h
	linux.qrc
	../common/LogonHelper.h
	../common/LogonHelper.cpp
	../common/PersistentLogonCredentials.h
	../common/PersistentLogonCredentials.cpp
	../common/ServiceDataManager.h
	../common/ServiceDataManager.cpp
	${libfakekey_SOURCES}
)

TARGET_INCLUDE_DIRECTORIES(linux-platform PRIVATE
	../common
	${libfakekey_DIR}
	${procps_INCLUDE_DIRS}
)

TARGET_LINK_LIBRARIES(linux-platform
	${X11_LIBRARIES}
	Qt5::DBus
	${procps_LDFLAGS}
	)

IF(fakekey_FOUND)
TARGET_INCLUDE_DIRECTORIES(linux-platform PRIVATE ${fakekey_INCLUDE_DIRS})
TARGET_LINK_LIBRARIES(linux-platform ${fakekey_LDFLAGS})
ELSE()
TARGET_INCLUDE_DIRECTORIES(linux-platform PRIVATE ${libfakekey_DIR})
TARGET_LINK_LIBRARIES(linux-platform ${X11_XTest_LIB})
ENDIF()

=== plugins/vncserver/x11vnc-builtin/CMakeLists.txt ===
include(BuildVeyonPlugin)

if(NOT VEYON_X11VNC_EXTERNAL)

find_package(LibVNCServer 0.9.8)
if(NOT LibVNCServer_FOUND)
	### BEGIN: libvncserver configuration
	include(LibVNCServerIntegration)

	set(_RFB_RFBCONFIG_H TRUE)
	set(LIBVNCSERVER_HAVE_LIBJPEG TRUE)
	set(LIBVNCSERVER_HAVE_LZO TRUE)
	set(LIBVNCSERVER_HAVE_LIBPNG TRUE)
	set(LIBVNCSERVER_HAVE_LIBPTHREAD TRUE)
	set(LIBVNCSERVER_HAVE_LIBZ TRUE)
	set(LIBVNCSERVER_HAVE_LIBSSL TRUE)
	set(LIBVNCSERVER_ALLOW24BPP TRUE)
	set(LIBVNCSERVER_IPv6 TRUE)
	### END: libvncserver configuration

	# write libvncserver configuration header
	file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/${VEYON_CORE_INCLUDE_DIR}/rfb)
	configure_file(${CMAKE_SOURCE_DIR}/3rdparty/libvncserver/rfb/rfbconfig.h.cmakein ${CMAKE_BINARY_DIR}/${VEYON_CORE_INCLUDE_DIR}/rfb/rfbconfig.h @ONLY)

endif()

set(FULL_PACKAGE_NAME "Veyon")
set(PACKAGE_VERSION "${VERSION_STRING}")
set(VERSION_PATCHLEVEL "${VERSION_PATCH}")

# check for x11vnc requirements
set(FUNCS getpwnam getspnam getuid grantpt initgroups seteuid setegid setgid setsid setuid shmat waitpid)
foreach(_func ${FUNCS})
	string(TOUPPER "${_func}" fuc)
	check_function_exists(${_func} HAVE_${fuc})
endforeach()

check_c_source_compiles("static __thread int p = 0; int main() {}" HAVE_TLS)

# x11vnc header macros
check_include_files(linux/fb.h HAVE_LINUX_FB_H)
check_include_files(linux/input.h HAVE_LINUX_INPUT_H)
check_include_files(linux/uinput.h HAVE_LINUX_UINPUT_H)
check_include_files(linux/videodev.h HAVE_LINUX_VIDEODEV_H)
check_include_files(netdb.h HAVE_NETDB_H)
check_include_files(netinet/in.h HAVE_NETINET_IN_H)
check_include_files(pwd.h HAVE_PWD_H)
check_include_files(sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_files(sys/stropts.h HAVE_SYS_STROPTS_H)
check_include_files(sys/wait.h HAVE_SYS_WAIT_H)
check_include_files(termios.h HAVE_TERMIOS_H)
check_include_files(utmpx.h HAVE_UTMPX_H)

find_package(X11 REQUIRED)

if(NOT X11_XTest_FOUND)
	message(FATAL_ERROR "XTest library or headers not found - please install libxtst-dev or libXtst-devel")
endif()

if(NOT X11_Xrandr_FOUND)
	message(FATAL_ERROR "Xrandr library or headers not found - please install libxrandr-dev or libXrandr-devel")
endif()

if(NOT X11_Xinerama_FOUND)
	message(FATAL_ERROR "Xinerama library or headers not found - please install libxinerama-dev or libXinerama-devel")
endif()

if(NOT X11_Xdamage_FOUND)
	message(FATAL_ERROR "Xdamage library or headers not found - please install libxdamage-dev or libXdamage-devel")
endif()

if(NOT X11_Xfixes_FOUND)
	message(FATAL_ERROR "Xfixes library or headers not found - please install libxfixes-dev or libXfixes-devel")
endif()

set(HAVE_X11 TRUE)
set(HAVE_XTEST TRUE)
set(HAVE_LIBSSL TRUE)
set(HAVE_LIBXINERAMA TRUE)
set(HAVE_LIBXRANDR TRUE)
set(HAVE_LIBXDAMAGE TRUE)
set(HAVE_LIBXFIXES TRUE)

if(X11_XShm_FOUND)
	set(HAVE_XSHM TRUE)
else()
	message("WARNING: XShm library or headers not found - building VNC server without XShm support")
endif()

if(X11_Xinput_FOUND)
	set(HAVE_XI2 TRUE)
else()
	message("WARNING: Xinput library or headers not found - building VNC server without Xinput support")
endif()

if(X11_Xcomposite_FOUND)
	set(HAVE_LIBXCOMPOSITE TRUE)
else()
	message("WARNING: Xcomposite library or headers not found - building VNC server without Xcomposite support")
endif()

if(X11_Xcursor_FOUND)
	set(HAVE_LIBXCURSOR TRUE)
else()
	message("WARNING: Xcursor library or headers not found - building VNC server without Xcursor support")
endif()

set(CMAKE_REQUIRED_LIBRARIES ${X11_LIBRARIES} ${X11_XTest_LIB})

check_function_exists(XReadScreen HAVE_SOLARIS_XREADSCREEN)
check_function_exists(FBPMForceLevel HAVE_FBPM)
check_function_exists(DPMSForceLevel HAVE_DPMS)
check_function_exists(XTestGrabControl HAVE_XTESTGRABCONTROL)
check_function_exists(XRecordEnableContextAsync HAVE_RECORD)
check_include_files(X11/extensions/readdisplay.h HAVE_IRIX_XREADDISPLAY)
check_include_files(X11/XKBlib.h HAVE_XKBLIB_H)
if(HAVE_XKBLIB_H)
	check_function_exists(XkbSelectEvents HAVE_XKEYBOARD)
endif()

set(CMAKE_REQUIRED_LIBRARIES ${OPENSSL_LIBRARIES})
check_function_exists(X509_print_ex_fp HAVE_X509_PRINT_EX_FP)

unset(CMAKE_REQUIRED_LIBRARIES)

set(X11VNC_CONFIG ${CMAKE_BINARY_DIR}/config.h)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)
if(NOT LibVNCServer_FOUND)
set(libvncserver_SOURCES
	${libvncserver_DIR}/libvncserver/auth.c
	${libvncserver_DIR}/libvncserver/cargs.c
	${libvncserver_DIR}/libvncserver/corre.c
	${libvncserver_DIR}/libvncserver/cursor.c
	${libvncserver_DIR}/libvncserver/cutpaste.c
	${libvncserver_DIR}/libvncserver/draw.c
	${libvncserver_DIR}/libvncserver/font.c
	${libvncserver_DIR}/libvncserver/hextile.c
	${libvncserver_DIR}/libvncserver/httpd.c
	${libvncserver_DIR}/libvncserver/main.c
	${libvncserver_DIR}/libvncserver/rfbregion.c
	${libvncserver_DIR}/libvncserver/rfbserver.c
	${libvncserver_DIR}/libvncserver/rre.c
	${libvncserver_DIR}/libvncserver/scale.c
	${libvncserver_DIR}/libvncserver/selbox.c
	${libvncserver_DIR}/libvncserver/sockets.c
	${libvncserver_DIR}/libvncserver/stats.c
	${libvncserver_DIR}/libvncserver/translate.c
	${libvncserver_DIR}/libvncserver/ultra.c
	${libvncserver_DIR}/libvncserver/zlib.c
	${libvncserver_DIR}/libvncserver/zrle.c
	${libvncserver_DIR}/libvncserver/zrleoutstream.c
	${libvncserver_DIR}/libvncserver/zrlepalettehelper.c
	${libvncserver_DIR}/libvncserver/tight.c
	${libvncserver_DIR}/common/d3des.c
	${libvncserver_DIR}/common/turbojpeg.c
	${libvncserver_DIR}/common/vncauth.c)
endif()

set(x11vnc_SOURCES x11vnc-veyon.c
	${x11vnc_DIR}/src/appshare.c
	${x11vnc_DIR}/src/avahi.c
	${x11vnc_DIR}/src/rates.c
	${x11vnc_DIR}/src/cleanup.c
	${x11vnc_DIR}/src/remote.c
	${x11vnc_DIR}/src/pointer.c
	${x11vnc_DIR}/src/userinput.c
	${x11vnc_DIR}/src/unixpw.c
	${x11vnc_DIR}/src/gui.c
	${x11vnc_DIR}/src/xkb_bell.c
	${x11vnc_DIR}/src/xinerama.c
	${x11vnc_DIR}/src/solid.c
	${x11vnc_DIR}/src/selection.c
	${x11vnc_DIR}/src/xrandr.c
	${x11vnc_DIR}/src/win_utils.c
	${x11vnc_DIR}/src/cursor.c
	${x11vnc_DIR}/src/screen.c
	${x11vnc_DIR}/src/xevents.c
	${x11vnc_DIR}/src/help.c
	${x11vnc_DIR}/src/inet.c
	${x11vnc_DIR}/src/sslcmds.c
	${x11vnc_DIR}/src/xwrappers.c
	${x11vnc_DIR}/src/scan.c
	${x11vnc_DIR}/src/options.c
	${x11vnc_DIR}/src/user.c
	${x11vnc_DIR}/src/util.c
	${x11vnc_DIR}/src/x11vnc_defs.c
	${x11vnc_DIR}/src/xrecord.c
	${x11vnc_DIR}/src/8to24.c
	${x11vnc_DIR}/src/xdamage.c
	${x11vnc_DIR}/src/keyboard.c
	${x11vnc_DIR}/src/connections.c
	${x11vnc_DIR}/src/sslhelper.c
	${x11vnc_DIR}/src/linuxfb.c
	${x11vnc_DIR}/src/v4l.c
	${x11vnc_DIR}/src/macosx.c
	${x11vnc_DIR}/src/macosxCG.c
	${x11vnc_DIR}/src/macosxCGP.c
	${x11vnc_DIR}/src/macosxCGS.c
	${x11vnc_DIR}/src/xi2_devices.c
	${x11vnc_DIR}/src/uinput.c
)

set_source_files_properties(${x11vnc_SOURCES} ${libvncserver_SOURCES} PROPERTIES COMPILE_FLAGS "-Wno-unused-result -Wno-unused-function -Wno-unused-variable -Wno-unused-but-set-variable -Wno-misleading-indentation -Wno-deprecated-declarations -Wno-address -Wno-format -Wno-discarded-qualifiers -Wno-strict-aliasing -Wno-restrict -Wno-multistatement-macros" COTIRE_EXCLUDED TRUE)

endif()

build_veyon_plugin(builtin-x11vnc-server
	BuiltinX11VncServer.cpp
	X11VncConfigurationWidget.cpp
	X11VncConfigurationWidget.ui
	${libvncserver_SOURCES}
	${x11vnc_SOURCES}
	BuiltinX11VncServer.h
	X11VncConfigurationWidget.h
	X11VncConfiguration.h
)

if(VEYON_X11VNC_EXTERNAL)

target_compile_definitions(builtin-x11vnc-server PRIVATE VEYON_X11VNC_EXTERNAL)

else()

target_compile_definitions(builtin-x11vnc-server PRIVATE VNCSHARED FOREVER NOREPEAT=0 NOPW=1 REMOTE_CONTROL=0 EXTERNAL_COMMANDS=0 FILEXFER=0 NOGUI SMALL_FOOTPRINT)

target_include_directories(builtin-x11vnc-server PRIVATE ${x11vnc_DIR}/src)

target_link_libraries(builtin-x11vnc-server
	${X11_LIBRARIES}
	${X11_XTest_LIB}
	${X11_Xfixes_LIB}
	${X11_Xinerama_LIB}
	${X11_Xdamage_LIB}
	${X11_Xrandr_LIB}
)

if(LibVNCServer_FOUND)
	#target_include_directories(builtin-x11vnc-server PRIVATE ${3rdparty_DIR} ${x11vnc_DIR}/src)
	target_link_libraries(builtin-x11vnc-server LibVNC::LibVNCServer)
else()
	target_include_directories(builtin-x11vnc-server PRIVATE ${libvncserver_DIR}/libvncserver ${libvncserver_DIR}/common)
endif()

if(X11_XShm_FOUND)
target_link_libraries(builtin-x11vnc-server ${X11_XShm_LIB})
endif()

if(X11_Xcomposite_FOUND)
target_link_libraries(builtin-x11vnc-server ${X11_Xcomposite_LIB})
endif()

if(X11_Xcursor_FOUND)
target_link_libraries(builtin-x11vnc-server ${X11_Xcursor_LIB})
endif()

if(X11_Xinput_FOUND)
target_link_libraries(builtin-x11vnc-server ${X11_Xinput_LIB})
endif()

endif()

=== debian/changelog ===
veyon (4.4.1+repack1-1) unstable; urgency=medium

  * New upstream release.
    - Stop using fixed logfile paths. (Closes: #964568).
    - Fix FTBFS in core/src/AccessControlProvider.cpp. (Closes: #964634).
  * debian/rules:
    + Drop libvncserver entirely from 3rdparty/ folder entirely.
  * debian/control:
    + Bump Standards-Version: to 4.5.0. No changes needed.
    + Bump versioned B-D on libvncserver-dev to (>= 0.9.13).
    + Add Rules-Requires-Root: field and set it to 'no'.
  * debian/patches:
    + Rebase 2002_no-bundled-kitemmodels.patch.
    + Trivial rebase of 2001_disable-CPackDefinitions-cmake.patch.
  * debian/copyright:
    + Update autogenerated copyright.in template file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 17 Jul 2020 08:48:04 +0200

=== debian/control ===
Source: veyon
Section: x11
Priority: optional
Maintainer: Debian Edu Packaging Team <debian-edu-pkg-team@lists.alioth.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends:
 cdbs,
 dpkg-dev (>= 1.16.1~),
 debhelper (>= 10),
 cmake,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 zlib1g-dev,
 liblzo2-dev,
 libjpeg-dev,
 libpng-dev,
 imagemagick,
 libpam0g-dev,
 libavahi-client-dev,
 libfakekey-dev,
 libkf5itemmodels-dev,
 libldap2-dev,
 libqca-qt5-2-dev,
 libprocps-dev,
 libsasl2-dev,
 libssl-dev,
 libsystemd-dev,
 libv4l-dev [linux-any],
 libvncserver-dev (>= 0.9.13),
 libxdamage-dev,
 libxext-dev,
 libxfixes-dev,
 libxss-dev,
 libxtst-dev,
 libxrandr-dev,
 libxinerama-dev,
 default-jdk | gcj-jdk | gcj,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://veyon.io/
Vcs-Git: https://salsa.debian.org/debian-edu-pkg-team/veyon.git
Vcs-Browser: https://salsa.debian.org/debian-edu-pkg-team/veyon/

Package: veyon-master
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libveyon-core (= ${binary:Version}),
 veyon-service (= ${binary:Version}),
 policykit-1,
Recommends:
 veyon-configurator,
Suggests:
 veyon-ctl,
Description: Computer Monitoring and Classroom Management Software - master
 Veyon is a software for computer monitoring and classroom management
 supporting Windows and Linux. It enables teachers to view and control
 computer labs and interact with students. Veyon is available in many different
 languages and provides numerous features supporting teachers and
 administrators at their daily work:
 .
   - Overview: monitor all computers in one or multiple locations or classrooms
   - Remote access: view or control computers to watch and support users
   - Demo: broadcast the teacher's screen in realtime (fullscreen/window)
   - Screen lock: draw attention to what matters right now
   - Communication: send text messages to students
   - Start and end lessons: log in and log out users all at once
   - Screenshots: record learning progress and document infringements
   - Programs & websites: launch programs and open website URLs remotely
   - Teaching material: distribute and open documents, images and videos easily
   - Administration: power on/off and reboot computers remotely
 .
 Veyon is the continuation of iTALC.
 .
 This package contains the veyon-master software. With veyon-master a teacher
 or tutor can control other machines if they run Veyon's client service software
 (package: veyon-service).

Package: veyon-service
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 adduser,
 libveyon-core (= ${binary:Version}),
 x11vnc,
Description: Computer Monitoring and Classroom Management Software - client service
 Veyon is a software for computer monitoring and classroom management
 supporting Windows and Linux. It enables teachers to view and control
 computer labs and interact with students. Veyon is available in many different
 languages and provides numerous features supporting teachers and
 administrators at their daily work:
 .
   - Overview: monitor all computers in one or multiple locations or classrooms
   - Remote access: view or control computers to watch and support users
   - Demo: broadcast the teacher's screen in realtime (fullscreen/window)
   - Screen lock: draw attention to what matters right now
   - Communication: send text messages to students
   - Start and end lessons: log in and log out users all at once
   - Screenshots: record learning progress and document infringements
   - Programs & websites: launch programs and open website URLs remotely
   - Teaching material: distribute and open documents, images and videos easily
   - Administration: power on/off and reboot computers remotely
 .
 Veyon is the continuation of iTALC.
 .
 This package contains Veyon's client service software which allows one to
 control a machine using the veyon-master software.

Package: veyon-configurator
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libveyon-core (=${binary:Version}),
Description: Computer Monitoring and Classroom Management Software - configurator
 Veyon is a software for computer monitoring and classroom management
 supporting Windows and Linux. It enables teachers to view and control
 computer labs and interact with students. Veyon is available in many different
 languages and provides numerous features supporting teachers and
 administrators at their daily work:
 .
   - Overview: monitor all computers in one or multiple locations or classrooms
   - Remote access: view or control computers to watch and support users
   - Demo: broadcast the teacher's screen in realtime (fullscreen/window)
   - Screen lock: draw attention to what matters right now
   - Communication: send text messages to students
   - Start and end lessons: log in and log out users all at once
   - Screenshots: record learning progress and document infringements
   - Programs & websites: launch programs and open website URLs remotely
   - Teaching material: distribute and open documents, images and videos easily
   - Administration: power on/off and reboot computers remotely
 .
 Veyon is the continuation of iTALC.
 .
 This package contains a graphical configuration manager for Veyon.

Package: libveyon-core
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 veyon-plugins (= ${binary:Version}),
Multi-Arch: same
Description: Computer Monitoring and Classroom Management Software - libraries
 Veyon is a software for computer monitoring and classroom management
 supporting Windows and Linux. It enables teachers to view and control
 computer labs and interact with students. Veyon is available in many different
 languages and provides numerous features supporting teachers and
 administrators at their daily work:
 .
   - Overview: monitor all computers in one or multiple locations or classrooms
   - Remote access: view or control computers to watch and support users
   - Demo: broadcast the teacher's screen in realtime (fullscreen/window)
   - Screen lock: draw attention to what matters right now
   - Communication: send text messages to students
   - Start and end lessons: log in and log out users all at once
   - Screenshots: record learning progress and document infringements
   - Programs & websites: launch programs and open website URLs remotely
   - Teaching material: distribute and open documents, images and videos easily
   - Administration: power on/off and reboot computers remotely
 .
 Veyon is the continuation of iTALC.
 .
 This package provides the core libraries needed for all Veyon components.

Package: veyon-plugins
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Multi-Arch: same
Description: Computer Monitoring and Classroom Management Software - plugins
 Veyon is a software for computer monitoring and classroom management
 supporting Windows and Linux. It enables teachers to view and control
 computer labs and interact with students. Veyon is available in many different
 languages and provides numerous features supporting teachers and
 administrators at their daily work:
 .
   - Overview: monitor all computers in one or multiple locations or classrooms
   - Remote access: view or control computers to watch and support users
   - Demo: broadcast the teacher's screen in realtime (fullscreen/window)
   - Screen lock: draw attention to what matters right now
   - Communication: send text messages to students
   - Start and end lessons: log in and log out users all at once
   - Screenshots: record learning progress and document infringements
   - Programs & websites: launch programs and open website URLs remotely
   - Teaching material: distribute and open documents, images and videos easily
   - Administration: power on/off and reboot computers remotely
 .
 Veyon is the continuation of iTALC.
 .
 This package provides Veyon's plugins.

=== debian/rules ===
#!/usr/bin/make -f

NULL =

include /usr/share/dpkg/buildflags.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk

common-binary-post-install-arch:: list-missing

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/pkg-info.mk

NULL  =
PKD   = $(word 2, abspath $(dir $(MAKEFILE_LIST)))
PKG   = $(DEB_SOURCE)
UVER  = $(shell echo $(DEB_VERSION) | cut -d "-" -f1)
DTYPE = +repack1
VER  ?= $(subst $(DTYPE),,$(UVER))

DEB_DH_INSTALL_SOURCEDIR = debian/tmp
DEB_DH_MAKESHLIBS_ARGS += -V

DEB_CMAKE_NORMAL_ARGS += -DCMAKE_SKIP_RPATH=OFF \
                         -DVEYON_X11VNC_EXTERNAL=ON \
                         -DDATAROOTDIR=/usr/share \
                         $(NULL)

DEB_DH_SHLIBDEPS_ARGS_veyon-master = -L libVeyonCore -l debian/libveyoncore/usr/lib/*/veyon
DEB_DH_SHLIBDEPS_ARGS_veyon-client = -L libVeyonCore -l debian/libveyoncore/usr/lib/*/veyon
DEB_DH_SHLIBDEPS_ARGS_veyon-management-console = -L libVeyonCore -l debian/libveyoncore/usr/lib/*/veyon
DEB_DH_SHLIBDEPS_ARGS_libveyoncore = -L libVeyonCore -l debian/libveyoncore/usr/lib/*/veyon

DEB_BUILD_PARALLEL = 1

common-install-arch::
	install -D -m 644 debian/icons/veyon-256x256.png debian/veyon-master/usr/share/icons/hicolor/256x256/apps/veyon-master.png
	install -D -m 644 core/resources/icon64.png debian/veyon-master/usr/share/icons/hicolor/64x64/apps/veyon-master.png
	install -D -m 644 core/resources/icon32.png debian/veyon-master/usr/share/icons/hicolor/32x32/apps/veyon-master.png
	install -D -m 644 core/resources/icon22.png debian/veyon-master/usr/share/icons/hicolor/22x22/apps/veyon-master.png
	install -D -m 644 core/resources/icon16.png debian/veyon-master/usr/share/icons/hicolor/16x16/apps/veyon-master.png

install/veyon-service::
	mkdir -p debian/tmp/usr/bin/
	mkdir -p debian/tmp/usr/lib/veyon/
	mkdir -p debian/tmp/etc/xdg/autostart/
	mkdir -p debian/tmp/usr/share/applications/
	mkdir -p debian/tmp/usr/share/veyon/

clean::
	rm -f config.log
	rm -f config.status

get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
	@

$(PKG)_$(VER)$(DTYPE).orig.tar.xz:
	@echo "# Downloading..."
	uscan --noconf --verbose --rename  --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER)
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Extracting..."
	mkdir $(PKG)-$(VER) \
	    && tar -xf $(PKG)_$(VER).orig.tar.bz2 --directory $(PKG)-$(VER) --strip-components 1 \
	    || $(RM) -r $(PKG)-$(VER)
	@echo "# Cleaning-up..."
	cd $(PKG)-$(VER) \
	    && $(RM) -r -v \
	       .ci/ \
	       .gitlab-ci.yml \
	       .travis/ \
	       .travis.yml \
	       3rdparty/ddengine/ \
	       3rdparty/libfakekey/ \
	       3rdparty/interception/ \
	       3rdparty/x11vnc/ \
	       3rdparty/ultravnc/ \
	       3rdparty/kitemmodels/ \
	       3rdparty/kldap/autotests/ \
	       3rdparty/kldap/kioslave/ \
	       3rdparty/libvncserver/ \
	       android/ \
	       cmake/build_mingw32 \
	       cmake/build_mingw64 \
	       cmake/modules/AndroidDeployQt.cmake \
	       cmake/modules/AndroidToolchain.cmake \
	       cmake/modules/MinGWCrossCompile.cmake \
	       cmake/modules/Win32Toolchain.cmake \
	       cmake/modules/Win64Toolchain.cmake \
	       configurator/data/veyon-configurator.ico \
	       contrib/ \
	       master/data/veyon-master.ico \
	       nsis/ \
	       plugins/platform/windows/ \
	       ica/x11/common/sha1.* \
	       ica/win32/ \
	       $(NULL)
	$(RM) -v $(PKG)_$(VER).orig.tar.*
	@echo "# Packing..."
	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
	    | XZ_OPT="-6v" tar -caf "../$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
	    && $(RM) -r "$(PKG)-$(VER)"
